#!/bin/bash

source ./fonctions.bash

# ========== Check the parameters

echo "argc = " $#

if [ $# -ne 1 ] ; then
	echo "FAIL"
	exit 1;
fi

# default values
outfile="second-jet.mp4"
mode=0
spool="LF"

if [ $1 == "HD" ] ; then
	outfile="finalmovie.mp4"
	mode=1
	spool="HD"
fi

# ----------------------------------
#      # ------------------functions

randomeffect ()
{
echo $(( RANDOM % 8 ))
}

randomcount ()
{
echo $(( 60 + (RANDOM % 120) ))
}

#	----------------------------------------------
#	bon, ici, il manque vraiment une indirection,
#	mais franchement, je ne sais pas comment traiter
#	ce truc simplement
#
action ()
{
# echo "ACTION $*"

if [ 1 -eq $mode ] ; then
	echo "wou: " $1 $2
	# convert $1 -resize 1920x1080\! $2
	agrandissement $1 '1920x1080!' $2
else
	plainvanilla $*
fi
}

#      # --------- main loop

echo "Go..."
rm $spool/*
> log.error

srcframe=0
dstframe=0
countmax=300
effect=$(randomeffect)
TOTALFRAMES=
for pass in $(seq 0 200)
do

	printf "=== Compositor === pass %4d src %4d dst %4d\n" 	\
				$pass $srcframe $dstframe
	case $effect in
		0)	sdir="b8/hdok"		;;
		1)	sdir="b8/3d"		;;
		2)	sdir="b8/bof"		;;
		3)	sdir="b8/itpl"		;;
		4)	sdir="b8/psy"		;;
		5)	sdir="b8/tro"		;;
		6)	sdir="b8/qsort"		;;
		7)	sdir="b8/c2x2"		;;
	esac
	printf "    effect %d   sdir = %s\n" $effect $sdir

	for index in $(seq 0 $countmax)
	do
		simg=$(printf "%s/%05d.png" $sdir $srcframe)
		dimg=$(printf "%s/%05d.png" $spool $dstframe)

		action $simg $dimg

		srcframe=$(( srcframe = srcframe + 1 ))
		dstframe=$(( dstframe = dstframe + 1 ))
	done

	# --- on ajoute un petit truc entre les sequences
	for foo in $(seq 0 12)
	do
		dimg=$(printf "%s/%05d.png"  $spool   $dstframe)
		action cumul.png $dimg
		dstframe=$(( dstframe = dstframe + 1 ))
	done

	effect=$(randomeffect)
	countmax=$(randomcount)

	if [ $srcframe -gt 6500 ] ; then
		echo "BREAK in pass " $pass 
		echo "dstframe = " $dstframe
		break
	fi

done

WAV="Sound/V2.wav"
	# XXX -i logo-tth.png -filter_complex "overlay=W-w-0:H-h-0"	\

ffmpeg  -nostdin                                                \
        -loglevel error                                         \
        -y -r 30 -f image2 -i $spool/%05d.png			\
	-i $WAV -ac 2						\
	-metadata artist="=[ tTh Ck2low Mutah ]="		\
        -c:v libx264 -pix_fmt yuv420p                           \
        $outfile

#      # --------- epic end

LANG=C date >> done/compositor
