

#include    <stdio.h>
#include    <stdlib.h>
#include    <math.h>

#include    <floatimg.h>

int		verbosity;

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  ** ** ** */
int do_the_real_thing(FloatImg *src, FloatImg *dst, int x, int y)
{
FloatImg		morceau;
FimgArea51		rectangle;
int			wsmall, hsmall;
int			foo;

#if DEBUG_LEVEL
fprintf(stderr, ">>> %s ( %p %p %d %d )\n", __func__,
			src, dst, x, y);
#endif

if (fimg_images_not_compatible(src, dst)) {
	fprintf(stderr, "bad karma in %s\n", __func__);
	exit(1);
	}

foo = fimg_auto_shift_to_zero(src, src);
if (foo) {
	fprintf(stderr, "%s: ERR %d shifting %p\n", __func__,
				foo,	src);
	exit(1);
	}

/* compute and buil the small image */
wsmall = src->width  / 2;
hsmall = src->height / 2;
foo = fimg_create(&morceau, wsmall, hsmall, FIMG_TYPE_RGB);

rectangle.x = x;
rectangle.y = y;
rectangle.w = wsmall;
rectangle.h = hsmall;

foo = fimg_extractor(src, &morceau, &rectangle);
if (foo) {
	fprintf(stderr, "%s: ERR %d in extractor\n", __func__, foo);
	exit(1);
	}

/* so, now we can brotch the fragment */
foo = fimg_cos_010(&morceau, &morceau, 1000.0);
if (foo) {
	fprintf(stderr, "%s: ERR %d mirrorig %p\n", __func__,
				foo,	src);
	exit(1);
	}

/* debuging dump */
// if (verbosity) fimg_dump_to_file(&morceau, "foo.fimg", 0);

/* en, after that, we MUST repoke that brotched fragment */
foo = fimg_incrustator_0(&morceau, dst, x, y, 0);
if (foo) {
	fprintf(stderr, "%s: ERR %d inserting %p in %p\n", __func__,
				foo,	&morceau, dst);
	exit(1);
	}

fimg_destroy(&morceau);

return 0;
}
/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  ** ** ** */

int prepare_action(char *fnsrc, char *fndst, int xp, int yp)
{
FloatImg	fIsrc, fIdst;
int		foo;

#if DEBUG_LEVEL
fprintf(stderr, ">>> %s ( '%s' '%s' %d %d )\n", __func__,
				fnsrc, fndst, xp, yp);
#endif

foo = fimg_create_from_dump(fnsrc, &fIsrc);
if (foo) {
	fprintf(stderr, "%s: ERR %d loading '%s'\n", __func__,
				foo,	fnsrc);
	exit(1);
	}

fimg_auto_shift_to_zero(&fIsrc, &fIsrc);

foo = fimg_clone(&fIsrc, &fIdst, 1);
// fimg_to_gray(&fIdst);

/*	+--------------------------+
	|     here was dragons     |
	+--------------------------+
*/
foo = do_the_real_thing(&fIsrc, &fIdst, xp, yp);
if (foo) {
	fprintf(stderr, "%s: ERR %d doing the thing on '%s'\n", __func__,
				foo,	fnsrc);
	exit(1);
	}
/*	!!!    end of dragons      !!!			*/

foo = fimg_dump_to_file(&fIdst, fndst,0);
if (foo) {
	fprintf(stderr, "%s: ERR %d dumping '%s'\n", __func__,
				foo,	fnsrc);
	exit(1);
	}

fimg_destroy(&fIsrc);	fimg_destroy(&fIdst);

return 0;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  ** ** ** */

int main(int argc, char *argv[])
{
int		foo;
int		xpos, ypos;

if (5 != argc) {
	fprintf(stderr, "!!! ERROR %s src.fimg dst.fimg x y\n",
				argv[0]);
	return 1;
	}

verbosity = 0;

xpos = (int)roundf(atof(argv[3]));
ypos = (int)roundf(atoi(argv[4]));

printf("%8d    %8d\n", xpos, ypos);	fflush(stdout);

// fimg_print_version(1);

foo = prepare_action(argv[1], argv[2], xpos, ypos);
if (verbosity) fprintf(stderr, "%s give --> %d\n", argv[0], foo);

return 0;
}
/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  ** ** ** */
