#!/bin/bash

SOURCE="A/"
SPOOL="b8/3d"
STEPS=9

outfile="povrayed3.mp4"

#	---------------------------------------------------------
do_raytracing ()
{
numimage=$1

DIMS=" -W1280 -H720"
QUAL=" +q9 +a "
OPTS=" -v -d +WT8 "
pngfile=$( printf "%s/%05d.png" $SPOOL $numimage )

CLINE="$DIMS $QUAL $OPTS +K${numimage} -Iscene.pov -O${pngfile} "
# printf "CLINE = %s\n" "$CLINE"

povray $CLINE -Iscene.pov -O$pngfile 2> pov.stderr
error=$?

if [ "0" != $error ]; then
	echo "error in raytracing, aborting"
	tail -20 pov.stderr
	exit 1
fi
echo "done for " $pngfile
}

#	---------------------------------------------------------

PNG="/dev/shm/picture.png"
INC="/dev/shm/picture.inc"
PREVIOUS="/dev/shm/previous.fimg"
CURRENT="/dev/shm/current.fimg"

mkfimg ${PREVIOUS} 1280 720

index=0
for fimg in $SOURCE/?????.fimg
do
	# echo "======== " ${fimg}

	fimgops  ${fimg} ${PREVIOUS} add ${CURRENT}

	fimg2text -s $STEPS -n  100 ${CURRENT}			|
			awk -f topovinc.awk	> $INC

	cp  ${fimg} ${PREVIOUS}

	do_raytracing $index
	index=$(( index + 1))

done

echo "=== Encoding" $outfile

ffmpeg	-nostdin						\
	-y -r 30 -f image2 -i "$SPOOL/%05d.png"			\
	-metadata artist="====[ tTh ]===="			\
	-c:v libx264 -pix_fmt yuv420p				\
	$outfile

LANG=C date >> done/raytrace

